<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2012 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class Artfu_Core {
  static function rename_item($item) {
    $inc_fn = 1;
    $to_item_id = module::get_var("artfu","to_item_id");
    $to_incr = module::get_var("artfu","to_incr");
    $inc_title = module::get_var("artfu","inc_title");
    $inc_url = module::get_var("artfu","inc_url");
    $to_prefix = module::get_var("artfu","to_prefix");
    $to_suffix = module::get_var("artfu","to_suffix");
    $fp = module::get_var("artfu","incr_start");
    $pad_zero = module::get_var("artfu","pad_zero");
    $incr_length = module::get_var("artfu","incr_length");

    if($to_prefix){ $to_prefix = module::get_var("artfu","to_prefix_val"); }
    if($to_suffix){ $to_suffix = module::get_var("artfu","to_suffix_val"); }

    if($item->is_photo()){
      $fn_ext = pathinfo($item->name, PATHINFO_EXTENSION);

      if($to_item_id){
	$firstpart = (string)$item->id;
      }

      if($to_incr){
	$tcount = ORM::factory("artfu_count")
	  ->where("album_id", "=", $item->parent_id)
	  ->find();
	if($tcount->loaded()){
	  $firstpart = $tcount->album_count + 1;
	  $tcount->album_count = $firstpart;
	  $tcount->save();
	} else {
	  if($fp){
	    $firstpart = $fp;
	  } else {
	    $firstpart = ORM::factory("item")
	      ->where("parent_id", "=", $item->parent_id)
	      ->find_all()
	      ->count();
	  }
	  $tcount->album_count = $firstpart;
	  $tcount->album_id = $item->parent_id;
	  $tcount->save();
	}
      }
      if($to_prefix){
	$firstpart = $to_prefix.$firstpart;
      }
      if($to_suffix){
	$firstpart .= $to_suffix;
      }

      if($pad_zero){
	$pz = "%0".$incr_length."d";
	$firstpart = sprintf($pz,$firstpart);
      }

// Ensure $firstpart is a string... else validation fails...
      if(!is_string($firstpart)){
	$firstpart = (string)$firstpart;
      }

      if($inc_url){
	$item->slug = $firstpart;
      }
      if($inc_fn){
	$oname = $item->name;
	$item->name = $firstpart.".".$fn_ext;
      }
      if($inc_title){
	$item->title = $firstpart;
      }
try {
  $item->validate();
} catch (ORM_Validation_Exception $e) {
  $errors = $e->validation->errors();
  message::warning($oname." was not auto-renamed - Unknown Error - See your logs!");
  Kohana_Log::add("error", "ARTFU: Validation test: [".gettype($item->slug)."] SLUG: '" . $item->slug."'");
  Kohana_Log::add("error", "ARTFU: Validation test: [".gettype($item->title)."] TITLE: '" . $item->title."'");
  Kohana_Log::add("error", "ARTFU: Validation errors: " . print_r($e->validation->errors(), 1));
  return;
}
      $item->save();
    }
  }
}
