<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2012 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA
 */
class artfu_installer {

  static function install() {
    // Create table if it doesn't exist for artfu storage
    $db = Database::instance();
    $db->query("CREATE TABLE IF NOT EXISTS {artfu_counts} (
               `id` int(9) NOT NULL auto_increment,
               `album_id` int(9) NOT NULL,
               `album_count` int(9) NOT NULL,
               PRIMARY KEY (`id`),
               KEY(`album_id`, `id`))
               DEFAULT CHARSET=utf8;");

    // Set the module version number.
    module::set_version("artfu", 5);

     site_status::warning(
        t("ARTFU Module needs to be configured. <a href=\"%url\">Configure it now!</a>",
        array("url" => html::mark_clean(url::site("admin/artfu")))),
        "artfu_configuration");
  }

  static function activate() {
    // Create table if it doesn't exist for artfu storage
    $db = Database::instance();
    $db->query("CREATE TABLE IF NOT EXISTS {artfu_counts} (
               `id` int(9) NOT NULL auto_increment,
               `album_id` int(9) NOT NULL,
               `album_count` int(9) NOT NULL,
               PRIMARY KEY (`id`),
               KEY(`album_id`, `id`))
               DEFAULT CHARSET=utf8;");

    // Set the module version number.
    module::set_version("artfu", 5);
     site_status::warning(
        t("ARTFU Module needs to be configured. <a href=\"%url\">Configure it now!</a>",
        array("url" => html::mark_clean(url::site("admin/artfu")))),
        "artfu_configuration");
  }

  static function deactivate() {
    Database::instance()->query("DROP TABLE IF EXISTS {artfu_counts}");
    site_status::clear("artfu_configuration");
  }

  static function uninstall() {
    Database::instance()->query("DROP TABLE IF EXISTS {artfu_counts}");
    site_status::clear("artfu_configuration");
  }

  static function can_activate() {
    $messages = array();
    if(module::get_var("gallery", "simultaneous_upload_limit") > 1){
      $messages["error"][] = t("This ARTFU module requires that 'simultaneous_upload_limit' be set to '1' in your advanced settings!");
    }
    return $messages;
  }
}
